//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "about.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TFormMain *FormMain;

//---------------------------------------------------------------------------
__fastcall TFormMain::TFormMain(TComponent* Owner)
  : TForm(Owner)
{
ActiveMatrixObject=NULL;
CurrMatrixObject=NULL;
ActiveListItem=NULL;
MatrixUndo=NULL;
MatrixRedo=NULL;
ActiveMathCommand=None;
SGMatrix->DoubleBuffered=true;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::Exit1Click(TObject *Sender)
{
Close();
}
//-----------------------------------------------------------------------------
void __fastcall TFormMain::About1Click(TObject *Sender)
{
TAboutBox* CurrAboutBox=new TAboutBox(this);
CurrAboutBox->ShowModal();
delete CurrAboutBox;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::CSpinEditMatrixRowsChange(TObject *Sender)
{
TestSingle();
SGMatrix->RowCount=CSpinEditMatrixRows->Value;
/*if(ActiveMatrixObject!=NULL&&!IsInMatrixList(ActiveMatrixObject))
{
  delete ActiveMatrixObject;
  ActiveMatrixObject=NULL;
}    */
if(CurrMatrixObject!=NULL&&!IsInMatrixList(CurrMatrixObject))
{
  delete CurrMatrixObject;
  CurrMatrixObject=NULL;
}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::CSpinEditMatrixColsChange(TObject *Sender)
{
TestSingle();
SGMatrix->ColCount=CSpinEditMatrixCols->Value;
/*if(ActiveMatrixObject!=NULL&&!IsInMatrixList(ActiveMatrixObject))
{
  delete ActiveMatrixObject;
  ActiveMatrixObject=NULL;
}*/
if(CurrMatrixObject!=NULL&&!IsInMatrixList(CurrMatrixObject))
{
  delete CurrMatrixObject;
  CurrMatrixObject=NULL;
}
}
//---------------------------------------------------------------------------
void TFormMain::TestSingle()
{
if(CSpinEditMatrixRows->Value>1||CSpinEditMatrixCols->Value>1)
{
  CBSingle->Checked=false;
  CBSingle->Enabled=false;
}
else
{
  CBSingle->Enabled=true;
}
}
//---------------------------------------------------------------------------
MatrixObject* __fastcall TFormMain::GridToMatrix()
{
CyrillicNotation=false;
try
{
  StrToFloat("0.1");
}
catch(...)
{
  CyrillicNotation=true;
}
String ReplaceWhat, ReplaceWith;
if(CyrillicNotation)
{
  ReplaceWhat=".";
  ReplaceWith=",";
}
else
{
  ReplaceWhat=",";
  ReplaceWith=".";
}
if(CBSingle->Checked)
{
  MatrixSingle* MatrixResult=new MatrixSingle();
  try
  {
    //if(currCellValue.Pos(ReplaceWhat))
      SGMatrix->Cells[0][0]=StrReplace(SGMatrix->Cells[0][0],ReplaceWhat,ReplaceWith);
    //else
    //  currCellValue=SGMatrix->Cells[0][0];
    MatrixResult->Value=StrToFloat(SGMatrix->Cells[0][0]);
  }
  catch(...)
  {
    SGMatrix->Cells[0][0]="0";
    MatrixResult->Value=0;
  }
  return MatrixResult;
}
else
{
  Matrix* MatrixResult=new Matrix(CSpinEditMatrixRows->Value,CSpinEditMatrixCols->Value);
  for(int i=0;i<MatrixResult->RowCount;i++)
  {
    for(int j=0;j<MatrixResult->ColumnCount;j++)
    {
      try
      {
        SGMatrix->Cells[j][i]=StrReplace(SGMatrix->Cells[j][i],ReplaceWhat,ReplaceWith);
        MatrixResult->Set(i,j,StrToFloat(SGMatrix->Cells[j][i]));
      }
      catch(...)
      {
        SGMatrix->Cells[j][i]="0";
        MatrixResult->Set(i,j,0);
      }
    }
  }
  return MatrixResult;
}
}
//---------------------------------------------------------------------------
bool __fastcall TFormMain::MatrixToGrid(MatrixObject* mxCurrMatrix)
{
if(mxCurrMatrix->MatrixType==mMatrix)
{
  Matrix* CurrMatrix=(Matrix*)mxCurrMatrix;
  CBSingle->Checked=false;
  CSpinEditMatrixRows->Value=CurrMatrix->RowCount;
  CSpinEditMatrixCols->Value=CurrMatrix->ColumnCount;
  for(int i=0;i<CurrMatrix->RowCount;i++)
  {
    for(int j=0;j<CurrMatrix->ColumnCount;j++)
    {
      SGMatrix->Cells[j][i]=String(CurrMatrix->Get(i,j));
    }
  }
}
else if(mxCurrMatrix->MatrixType==mSingle)
{
  MatrixSingle* CurrMatrix=(MatrixSingle*)mxCurrMatrix;
  CSpinEditMatrixRows->Value=1;
  CSpinEditMatrixCols->Value=1;
  SGMatrix->Cells[0][0]=String(CurrMatrix->Value);
  CBSingle->Checked=true;
}
return true;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnAddClick(TObject *Sender)
{
if(EditName->Text=="")
{
  if(CBSingle->Checked)
  {
    EditName->Text="Single";
  }
  else
  {
    EditName->Text="Matrix";
  }
}
AddToMatrixList(GridToMatrix(),EditName->Text);
}
void __fastcall TFormMain::AddToMatrixList(MatrixObject* CurrMatrix,const String& CurrMatrixCaption)
{
TListItem* NewItem=LVMatrix->Items->Add();
NewItem->Caption=GenerateName(CurrMatrixCaption);
NewItem->SubItems->Append(String(CSpinEditMatrixRows->Value));
NewItem->SubItems->Append(String(CSpinEditMatrixCols->Value));
NewItem->Data=CurrMatrix;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::LVMatrixChange(TObject *Sender, TListItem *Item,
      TItemChange Change)
{
if(Item!=NULL&&Item->Data!=NULL)
{
  MatrixToGrid((MatrixObject*)Item->Data);
  EditName->Text=Item->Caption;
  ActiveListItem=Item;
}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::FormDestroy(TObject *Sender)
{
if(ActiveMatrixObject!=NULL)
{
  delete ActiveMatrixObject;
  ActiveMatrixObject=NULL;
}
if(CurrMatrixObject!=NULL)
{
  delete CurrMatrixObject;
  CurrMatrixObject=NULL;
}
for(int i=0;i<LVMatrix->Items->Count;i++)
{
  if(LVMatrix->Items->Item[i]->Data!=NULL)
  {
    delete (MatrixObject*)LVMatrix->Items->Item[i]->Data;
    LVMatrix->Items->Item[i]->Data=NULL;
  }
}
delete MatrixUndo;
delete MatrixRedo;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnIsClick(TObject *Sender)
{
if(ActiveMatrixObject==NULL)
  return;
if(CurrMatrixObject==NULL)
  CurrMatrixObject=GridToMatrix();
else
  ActiveMatrixObject=GridToMatrix();
if(CurrMatrixObject->MatrixType==mMatrix&&ActiveMatrixObject->MatrixType==mMatrix)
{
  MatrixUndo=GridToMatrix();
  Matrix* CurrMatrix=(Matrix*)CurrMatrixObject;
  Matrix* ActiveMatrix=(Matrix*)ActiveMatrixObject;
  switch(ActiveMathCommand)
  {
    case Plus:
      try
      {
        MatrixToGrid(*ActiveMatrix+*CurrMatrix);
      }
      catch(const exception& e)
      {
        ActiveMathCommand=Plus;
        ShowError(e.what());
      }
    break;
    case Minus:
      try
      {
        MatrixToGrid(*ActiveMatrix-*CurrMatrix);
      }
      catch(const exception& e)
      {
        ShowError(e.what());
      }
    break;
    case Multiplication:
      
      try
      {
        MatrixToGrid((*ActiveMatrix)*(*CurrMatrix));
      }
      catch(const exception& e)
      {
        ShowError(e.what());
      }
    break;
    case Division:
      MatrixToGrid((*ActiveMatrix)/(*CurrMatrix));
    break;
  }
  if(CBAutoEPS->Checked)
    BtnByEPSClick(Sender);
}
else if(CurrMatrixObject->MatrixType==mSingle&&ActiveMatrixObject->MatrixType==mSingle)
{
  MatrixUndo=GridToMatrix();
  MatrixSingle* CurrMatrix=(MatrixSingle*)CurrMatrixObject;
  MatrixSingle* ActiveMatrix=(MatrixSingle*)ActiveMatrixObject;
  switch(ActiveMathCommand)
  {
    case Plus:
      try
      {
        MatrixToGrid(*ActiveMatrix+*CurrMatrix);
      }
      catch(const exception& e)
      {
        ShowError(e.what());
      }
    break;
    case Minus:
      try
      {
        MatrixToGrid(*ActiveMatrix-*CurrMatrix);
      }
      catch(const exception& e)
      {
        ShowError(e.what());
      }
    break;
    case Multiplication:
      try
      {
        MatrixToGrid((*ActiveMatrix)*(*CurrMatrix));
      }
      catch(const exception& e)
      {
        ShowError(e.what());
      }
    break;
    case Division:
      MatrixToGrid((*ActiveMatrix)/(*CurrMatrix));
    break;
  }
  if(CBAutoEPS->Checked)
    BtnByEPSClick(Sender);
}
else if(CurrMatrixObject->MatrixType==mSingle&&ActiveMatrixObject->MatrixType==mMatrix)
{                                        
  MatrixUndo=GridToMatrix();
  Matrix* CurrMatrix=(Matrix*)CurrMatrixObject;
  MatrixSingle* ActiveMatrix=(MatrixSingle*)ActiveMatrixObject;
  switch(ActiveMathCommand)
  {
    case Multiplication:
      try
      {
        MatrixToGrid((*CurrMatrix)*(ActiveMatrix->Value));
      }
      catch(const exception& e)
      {
        ShowError(e.what());
      }
    break;
    case Division:
      MatrixToGrid((*CurrMatrix)/ActiveMatrix->Value);
    break;
  }
  if(CBAutoEPS->Checked)
    BtnByEPSClick(Sender);
}
else if(CurrMatrixObject->MatrixType==mMatrix&&ActiveMatrixObject->MatrixType==mSingle)
{                                        
  MatrixUndo=GridToMatrix();
  Matrix* ActiveMatrix=(Matrix*)ActiveMatrixObject;
  MatrixSingle* CurrMatrix=(MatrixSingle*)CurrMatrixObject;
  switch(ActiveMathCommand)            
  {
    case Multiplication:
      try
      {
        MatrixToGrid((*ActiveMatrix)*CurrMatrix->Value);
      }
      catch(const exception& e)
      {
        ShowError(e.what());
      }
    break;
  }
  if(CBAutoEPS->Checked)
    BtnByEPSClick(Sender);
}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ShowError(const String& StrErrorText)
{
MessageDlg(StrErrorText,mtError,TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnPlusClick(TObject *Sender)
{
if(ActiveMatrixObject!=NULL)
  delete ActiveMatrixObject;
ActiveMatrixObject=GridToMatrix();
if(CurrMatrixObject!=NULL&&!IsInMatrixList(CurrMatrixObject))
{
  delete CurrMatrixObject;
  CurrMatrixObject=NULL;
}
ActiveMathCommand=Plus;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnMinClick(TObject *Sender)
{
if(ActiveMatrixObject!=NULL)
  delete ActiveMatrixObject;
ActiveMatrixObject=GridToMatrix();
if(CurrMatrixObject!=NULL&&!IsInMatrixList(CurrMatrixObject))
{
  delete CurrMatrixObject;
  CurrMatrixObject=NULL;
}
ActiveMathCommand=Minus;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnMultClick(TObject *Sender)
{
if(ActiveMatrixObject!=NULL)
  delete ActiveMatrixObject;
ActiveMatrixObject=GridToMatrix();
if(CurrMatrixObject!=NULL&&!IsInMatrixList(CurrMatrixObject))
{
  delete CurrMatrixObject;
  CurrMatrixObject=NULL;
}
ActiveMathCommand=Multiplication;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnDivClick(TObject *Sender)
{
if(ActiveMatrixObject!=NULL)
  delete ActiveMatrixObject;
ActiveMatrixObject=GridToMatrix();
if(CurrMatrixObject!=NULL&&!IsInMatrixList(CurrMatrixObject))
{
  delete CurrMatrixObject;
  CurrMatrixObject=NULL;
}
ActiveMathCommand=Division;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnEClick(TObject *Sender)
{
if(CBSingle->Checked)
  return;
if(SGMatrix->Cells[0][0]==""||SGMatrix->Cells[0][0]=="0")
{
  try
  {
    MatrixUndo=GridToMatrix();
    MatrixToGrid(((Matrix*)GridToMatrix())->GetE(1));
  }
  catch(const exception& e)
  {
    ShowError(e.what());
  }
}
else
{
  try
  {
    MatrixToGrid(((Matrix*)GridToMatrix())->GetE(StrToFloat(SGMatrix->Cells[0][0])));
  }
  catch(const exception& e)
  {
    ShowError(e.what());
  }
}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnTranClick(TObject *Sender)
{
if(CBSingle->Checked)
  return;
try
{
  MatrixUndo=GridToMatrix();
  MatrixToGrid(((Matrix*)GridToMatrix())->Transpose());
}
catch(const exception& e)
{
  ShowError(e.what());
}
if(CBAutoEPS->Checked)
  BtnByEPSClick(Sender);
}
//---------------------------------------------------------------------------
String __fastcall TFormMain::GenerateName(const String& strPattern)
{
int i=0;
String Pattern=strPattern;
String Result=strPattern;
while(IsInMatrixList(Result)!=NULL)
{
  i++;
  Result=strPattern+String(i);
}
return Result;
}

TListItem* __fastcall TFormMain::IsInMatrixList(String strElem)
{
for(int i=0;i<LVMatrix->Items->Count;i++)
  if(LVMatrix->Items->Item[i]->Caption==strElem)
    return LVMatrix->Items->Item[i];
return NULL;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnRemoveClick(TObject *Sender)
{
if(LVMatrix->ItemFocused!=NULL)
{
  if(LVMatrix->ItemFocused->Data!=NULL)
  {
    delete LVMatrix->ItemFocused->Data;
    LVMatrix->ItemFocused->Data=NULL;
  }
  LVMatrix->Items->Delete(LVMatrix->ItemFocused->Index);
}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnRndIntClick(TObject *Sender)
{
if(CBSingle->Checked)
{
  MatrixSingle* CurrMatrix=(MatrixSingle*)GridToMatrix();
  CurrMatrix->RandomInt(CurrMatrix->Value);
  MatrixToGrid(CurrMatrix);
}
else
{
  Matrix* CurrMatrix=(Matrix*)GridToMatrix();
  try
  {
    MatrixUndo=GridToMatrix();
    CurrMatrix->RandomInt();
    MatrixToGrid(CurrMatrix);
  }
  catch(const exception& e)
  {
    ShowError(e.what());
  }
}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnRndFloatClick(TObject *Sender)
{
if(CBSingle->Checked)
{
  MatrixSingle* CurrMatrix=(MatrixSingle*)GridToMatrix();
  CurrMatrix->RandomDouble();
  MatrixToGrid(CurrMatrix);
}
else
{
  Matrix* CurrMatrix=(Matrix*)GridToMatrix();
  try
  {
    MatrixUndo=GridToMatrix();
    CurrMatrix->RandomDouble();
    MatrixToGrid(CurrMatrix);
  }
  catch(const exception& e)
  {
    ShowError(e.what());
  }
}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnTriClick(TObject *Sender)
{
if(CBSingle->Checked)
  return;
else
{
  try
  {
    MatrixUndo=GridToMatrix();
    Matrix* CurrMatrix=((Matrix*)GridToMatrix())->ToSteps();
    MatrixToGrid(CurrMatrix);
  }
  catch(const exception& e)
  {
    ShowError(e.what());
  }
  if(CBAutoEPS->Checked)
    BtnByEPSClick(Sender);
}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnLUClick(TObject *Sender)
{
if(CBSingle->Checked)
  return;
else
{
  Matrix* CurrMatrix=(Matrix*)GridToMatrix(); 
  Matrix* MatrixU=new Matrix(CurrMatrix->RowCount);
  Matrix* MatrixL=new Matrix(CurrMatrix->RowCount);
  try
  {
    MatrixUndo=GridToMatrix();
    CurrMatrix->ExpantionLU(*MatrixL,*MatrixU);
    AddToMatrixList(MatrixL,EditName->Text+"_MatrixL");
    AddToMatrixList(MatrixU,EditName->Text+"_MatrixU");
  }
  catch(const exception& e)
  {
    ShowError(e.what());
  }
  if(CBAutoEPS->Checked)
    BtnByEPSClick(Sender);
}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnDefClick(TObject *Sender)
{
if(CBSingle->Checked)
  return;
else
{
  try
  {
    MatrixUndo=GridToMatrix();
    MatrixToGrid(new MatrixSingle(((Matrix*)GridToMatrix())->GetDet()));
  }
  catch(const exception& e)
  {
    ShowError(e.what());
  }
  if(CBAutoEPS->Checked)
    BtnByEPSClick(Sender);
}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnInvClick(TObject *Sender)
{
if(CBSingle->Checked)
  return;
else
{
  try
  {
    Matrix* CurrMatrix=((Matrix*)GridToMatrix())->Inverse();
    MatrixUndo=GridToMatrix();
    MatrixToGrid(CurrMatrix);
  }
  catch(const exception& e)
  {
    ShowError(e.what());
  }
  if(CBAutoEPS->Checked)
    BtnByEPSClick(Sender);
}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::File1Click(TObject *Sender)
{
if(Clipboard()->HasFormat(CF_TEXT))
{
  Paste1->Enabled=true;
}
else
{
  Paste1->Enabled=false;
}
if(MatrixUndo!=NULL||MatrixRedo!=NULL)
{
  Undo1->Enabled=true;
  if(MatrixUndo!=NULL)
    Undo1->Caption="Undo";
  else
    Undo1->Caption="Redo";
}
else
{
  Undo1->Enabled=false;
  Undo1->Caption="Undo";
}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::Copy1Click(TObject *Sender)
{
MatrixObject* CurrMatrixObject=GridToMatrix();
switch(CurrMatrixObject->MatrixType)
{
  case mMatrix:
    Clipboard()->SetTextBuf(((Matrix*)CurrMatrixObject)->ToChar());
  break;
  case mSingle:
    Clipboard()->SetTextBuf(((MatrixSingle*)CurrMatrixObject)->ToChar());
  break;
}
delete CurrMatrixObject;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::Paste1Click(TObject *Sender)
{
String StrBuff=Clipboard()->AsText;
TStrings* CurrMatrixStrings=new TStringList();
int CurrPos=0;
do
{
  CurrPos=StrBuff.Pos("\r\n");
  if(CurrPos>0)
  {
    CurrMatrixStrings->Append(StrBuff.SubString(1,CurrPos-1));
    StrBuff=StrBuff.Delete(1,CurrPos+1);
  }
  else
    CurrMatrixStrings->Append(StrBuff);
}while(CurrPos>0);
CSpinEditMatrixRows->Value=CurrMatrixStrings->Count;
CurrPos=0;
for(int i(0), j(0);i<CurrMatrixStrings->Count;i++,j=0)
{
  do
  {
    CurrPos=CurrMatrixStrings->Strings[i].Pos(";");
    if(CurrPos>0)
    {
      if(j==CSpinEditMatrixCols->Value)
        CSpinEditMatrixCols->Value++;
      SGMatrix->Cells[j][i]=CurrMatrixStrings->Strings[i].SubString(1,CurrPos-1);
      CurrMatrixStrings->Strings[i]=CurrMatrixStrings->Strings[i].Delete(1,CurrPos);
    }
    else
    {
      SGMatrix->Cells[j][i]=CurrMatrixStrings->Strings[i];
    }
    j++;
  }while(CurrPos>0);
}
delete CurrMatrixStrings;
}
int __fastcall TFormMain::CountInStr(const String& Str,const String& Item)
{
int ItemLen=Item.Length();
int StrLen=Str.Length()-ItemLen;
int Num=0;
for(int i=0;i<StrLen;i++)
  if(Str.SubString(i,ItemLen)==Item)
    Num++;
return Num;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnCtrlClick(TObject *Sender)
{
if(CBSingle->Checked)
  return;
else
{
  try
  {
    MatrixUndo=GridToMatrix();
    MatrixToGrid(((Matrix*)GridToMatrix())->WithControlColumn());
  }
  catch(const exception& e)
  {
    ShowError(e.what());
  }
  if(CBAutoEPS->Checked)
    BtnByEPSClick(Sender);
}
}
//---------------------------------------------------------------------------
bool __fastcall TFormMain::IsInMatrixList(MatrixObject* matrix)
{
  for(int i=0;i<LVMatrix->Items->Count;i++)
    if(((MatrixObject*)LVMatrix->Items->Item[i]->Data)==matrix)
      return true;
  return false;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::Undo1Click(TObject *Sender)
{
if(MatrixUndo!=NULL)
{
  MatrixRedo=GridToMatrix();
  MatrixToGrid(MatrixUndo);
  delete MatrixUndo;
  MatrixUndo=NULL;
}
else
{
  MatrixUndo=GridToMatrix();
  MatrixToGrid(MatrixRedo);
  delete MatrixRedo;
  MatrixRedo=NULL;
}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnByEPSClick(TObject *Sender)
{
double CurrEPS;
try
{
  CurrEPS=StrToFloat(EditEPS->Text);
}
catch(...)
{
  CurrEPS=0.000001;
  EditEPS->Text=FloatToStr(CurrEPS);
}
if(CBSingle->Checked)
{
  MatrixSingle* CurrMatrix=(MatrixSingle*)GridToMatrix();
  if(fabs(CurrMatrix->Value)<CurrMatrix->Value)
    CurrMatrix->Value=0;
  MatrixToGrid(CurrMatrix);
}
else
{
  Matrix* CurrMatrix=(Matrix*)GridToMatrix();
  try
  {
    CurrMatrix->ClearByEPS(CurrEPS);
    MatrixToGrid(CurrMatrix);
  }
  catch(const exception& e)
  {
    ShowError(e.what());
  }
}
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::BtnFourierClick(TObject *Sender)
{
/*if(CBSingle->Checked)
  return;
else
{
  double x = 0;
  String StrX=0;
  if(InputQuery("Input X", "Please, input the x value.", StrX))
  {
    try
    {
      x=StrX.ToDouble();
    }
    catch(const EConvertError& e)
    {
       ShowError(e.Message);
       return;
    }
    try
    {
      MatrixUndo=GridToMatrix();
      MatrixToGrid(new MatrixSingle(((Matrix*)GridToMatrix())->Fourier(x)));
      if(CBAutoEPS->Checked)
        BtnByEPSClick(Sender);
    }
    catch(const exception& e)
    {
      ShowError(e.what());
    }
  }
}        */
}
//---------------------------------------------------------------------------
String __fastcall TFormMain::StrReplace(const String& Str, const String& What, const String& With)
{
  String Result=Str;
  int currPos=0;
  while((currPos = Result.Pos(What)) > 0)
    Result=Result.SubString(1,currPos-1)+With+Result.SubString(currPos+1,Result.Length()-currPos);
  return Result;
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::ButtonSaveChangesClick(TObject *Sender)
{
if(ActiveListItem!=NULL)
{
  if(ActiveListItem->Data!=NULL)
    delete ActiveListItem->Data;
  ActiveListItem->Data=GridToMatrix();
  ActiveListItem->Caption=EditName->Text;
}
else
  BtnAddClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormMain::Timer1Timer(TObject *Sender)
{
if(ActiveListItem!=NULL)
{
  ButtonSaveChanges->Caption="Save "+ActiveListItem->Caption;
}
else
{
  if(EditName->Text!="")
    ButtonSaveChanges->Caption="Save "+EditName->Text;
  else
    ButtonSaveChanges->Caption="Save";
}
}
//---------------------------------------------------------------------------

